Wrapper class that holds all information necessary to create a task that did not exist when Phing started.

This has something to do with phing encountering an task XML element it is not aware of at start time. This is a situation where special steps need to be taken so that the element is then known.

author | Andreas Aderhold
author | Hans Lellelid
version | $Id$
package | phing
copyright | 2001,2002 THYRELL. All rights reserved

### Methods

## Constructs a UnknownElement object

    __construct(string $elementName)

access | public

### Parameters

#### $elementName

`string`

The XML element name that is unknown

## Add a child element to the unknown element

    addChild(\UnknownElement $child)

### Parameters

#### $child

`object`

The object representing the child element

## Returns the textual description of the task

    getDescription() : string

Inherited

inherited_from | \Task::getDescription()

### Returns

`string`The text description of the task

## Returns the location within the buildfile this task occurs.

    getLocation() : \Location

Inherited

Used by BuildException to give detailed error messages.

inherited_from | \Task::getLocation()

### Returns

`\Location`The location object describing the position of this task within the buildfile.

## Returns the owning target of this task.

    getOwningTarget() : \Target

Inherited

inherited_from | \Task::getOwningTarget()

### Returns

`\Target`The target object that owns this task

## Returns a reference to current project

    getProject() : \Project

Inherited

inherited_from | \ProjectComponent::getProject()
inherited_from | \Task::getProject()

### Returns

`\Project`Reference to current porject object

## Returns the wrapper object for runtime configuration

    getRuntimeConfigurableWrapper() : \RuntimeConfigurable

Inherited

inherited_from | \Task::getRuntimeConfigurableWrapper()

### Returns

`\RuntimeConfigurable`The wrapper object used by this task

## Return the XML element name that this <code>UnnownElement</code> handles.

    getTag() : string

### Returns

`string`The XML element name that is unknown

## Get the name of the task to use in logging messages.

    getTaskName() : string

@return string The task's name

### Returns

`string`Name of this task

## Returns the name of the task under which it was invoked, usually the XML tagname

    getTaskType() : string

Inherited

inherited_from | \Task::getTaskType()

### Returns

`string`The type of this task (XML Tag)

## Handle child elemets of the unknown element, if any.

    handleChildren($parent, object $parentWrapper)

@param object $parent The parent object the unkown element belongs to

### Parameters

#### $parent

#### $parentWrapper

`object`

The parent wrapper object

## Called by the parser to let the task initialize properly.

    init()

Inherited

Should throw a BuildException if something goes wrong with the build

This is abstract here, but may not be overloaded by subclasses.

inherited_from | \Task::init()

### Exceptions

`\BuildException` |

## Provides a project level log event to the task.

    log(string $msg, integer $level)

Inherited

see | \global\BuildEvent
see | \global\BuildListener
inherited_from | \Task::log()

### Parameters

#### $msg

`string`

The message to log

#### $level

`integer`

The priority of the message

## Called when the real task has been configured for the first time.

    main()

This method may be called more than once, if the task is invoked more than once. For example, if target1 and target2 both depend on target3, then running phing target1 target2 will run all tasks in target3 twice.

Should throw a BuildException if someting goes wrong with the build

This is abstract here. Must be overloaded by real tasks.

### Exceptions

`\BuildException` | if the task can not be created

## Tries to configure the unknown element

    maybeConfigure()

### Exceptions

`\BuildException` | if the element can not be configured

## Perfrom this task

    perform()

Inherited

inherited_from | \Task::perform()

## Sets a textual description of the task

    setDescription(string $desc)

Inherited

inherited_from | \Task::setDescription()

### Parameters

#### $desc

`string`

The text describing the task

## Sets the location within the buildfile this task occurs.

    setLocation(\Location $location)

Inherited

Called by the parser to set location information.

inherited_from | \Task::setLocation()

### Parameters

#### $location

`\Location`

The location object describing the position of this task within the buildfile.

## Sets the owning target this task belongs to.

    setOwningTarget(\Target $target)

Inherited

inherited_from | \Task::setOwningTarget()

### Parameters

#### $target

`\Target`

Reference to owning target

## References the project to the current component.

    setProject(\Project $project)

Inherited

inherited_from | \ProjectComponent::setProject()
inherited_from | \Task::setProject()

### Parameters

#### $project

`\Project`

The reference to the current project

## Sets the wrapper object this task should use for runtime configurable elements.

    setRuntimeConfigurableWrapper(\RuntimeConfigurable $wrapper)

Inherited

inherited_from | \Task::setRuntimeConfigurableWrapper()

### Parameters

#### $wrapper

`\RuntimeConfigurable`

The wrapper object this task should use

## Sets the name of this task for log messages

    setTaskName(string $name) : string

Inherited

inherited_from | \Task::setTaskName()

### Parameters

#### $name

`string`

### Returns

`string`A string representing the name of this task for log

## Sets the type of the task.

    setTaskType(string $name)

Inherited

Usually this is the name of the XML tag

inherited_from | \Task::setTaskType()

### Parameters

#### $name

`string`

The type of this task (XML Tag)

## Returns a name

    getRegisterSlot(string $slotName)

Inherited

inherited_from | \Task::getRegisterSlot()

### Parameters

#### $slotName

`string`

## Creates a named task or data type.

    makeObject(\UnknownElement $ue, \RuntimeConfigurable $w) : object

If the real object is a task, it is configured up to the init() stage.

### Parameters

#### $ue

`\UnknownElement`

The unknown element to create the real object for. Must not be `null`.

#### $w

`\RuntimeConfigurable`

Ignored in this implementation.

### Returns

`object`The Task or DataType represented by the given unknown element.

## Create a named task and configure it up to the init() stage.

    makeTask(\UnknownElement $ue, \RuntimeConfigurable $w, boolean $onTopLevel) : \Task

### Parameters

#### $ue

`\UnknownElement`

The unknwon element to create a task from

#### $w

`\RuntimeConfigurable`

The wrapper object

#### $onTopLevel

`boolean`

Whether to treat this task as if it is top-level.

### Returns

`\Task`The freshly created task

### Properties

##

    $description : string

Inherited

inherited_from | \Task::$$description

##

    $location : \Location

Inherited

inherited_from | \Task::$$location

##

    $project : \Project

Inherited

inherited_from | \ProjectComponent::$$project
inherited_from | \Task::$$project

##

    $target : \Target

Inherited

inherited_from | \Task::$$target

##

    $taskName : string

Inherited

inherited_from | \Task::$$taskName

##

    $taskType : string

Inherited

inherited_from | \Task::$$taskType

##

    $wrapper : \RuntimeConfigurable

Inherited

inherited_from | \Task::$$wrapper

##

    $children

##

    $elementName

##

    $realThing